//
// 
// Tracking an object with another.
//
//! \file obj_tracker
//! \author J Vijn
//! \date 20080316 - 20080316
//
/* === NOTES ===
  * Not very clean, but functional.
*/

#include <stdlib.h>
#include <tonc.h>

// --------------------------------------------------------------------
// FUNCTIONS 
// --------------------------------------------------------------------

void obj_tracker()
{	irq_init(NULL);
	irq_add(II_VBLANK, NULL);

	// --- Init graphics ---
	const u32 tiles[2*32]= {
			
		0x00000000, 
		0x00000000, 
		0x00000011, 
		0x00011100, 
		0x11102000, 
		0x00011100, 
		0x00000011, 
		0x00000000, 
	
		0x00000000, 
		0x00020000,
		0x00020000,
		0x00020000,
		0x22222220,
		0x00020000,
		0x00020000,
		0x00020000,
	};

	memcpy32(&tile_mem[4][1], tiles, countof(tiles));

	pal_obj_mem[1]= CLR_RED;
	pal_obj_mem[2]= CLR_YELLOW;

	// --- Init some objects ---
	OBJ_ATTR objs[8];
	OBJ_AFFINE *oa= (OBJ_AFFINE*)objs;
	oam_init(objs, 8);

	int x0=120, y0=80, x1= 200, y1= 40;
	obj_set_attr(&objs[0], ATTR0_SQUARE | ATTR0_AFF, ATTR1_AFF_ID(0), 1);
	obj_set_attr(&objs[1], ATTR0_SQUARE | ATTR0_REG, 0, 2);

	// --- Init text ---
	REG_DISPCNT= DCNT_MODE0 | DCNT_BG0 | DCNT_OBJ;
	tte_init_chr4(0, BG_CBB(0)|BG_SBB(31), 0, 15, CLR_ORANGE, NULL, NULL);
	tte_init_con();
	tte_set_margins(8,8, 128, 24);

	while(1)
	{
		VBlankIntrWait();
		key_poll();

		// Update position of obj 1
		x1 += key_tri_horz();
		y1 += key_tri_vert();

		// Calculate direction.
		int dx= x1-x0, dy= y1-y0;		// direction vars
		uint norm= Sqrt(dx*dx + dy*dy);
		dx= Div(dx<<8, norm);
		dy= Div(dy<<8, norm);

		obj_set_pos(&objs[0], x0-4, y0-4);
		obj_set_pos(&objs[1], x1-4, y1-4);

		// Update matrix (cos, sin ; -sin, cos)
		obj_aff_set(&oa[0], dx, dy, -dy, dx);
		
		oam_copy(oam_mem, objs, 8);
		tte_printf("#{es;P}%d, %d", dx, dy);
	}
}


int main()
{
	obj_tracker();

	return 0;
}

// EOF
